Whamcloud - gitweb
b=11270
[fs/lustre-release.git] / lustre / tests / sanityN.sh
1 #!/bin/bash
2
3 set -e
4
5 ONLY=${ONLY:-"$*"}
6 # bug number for skipped test:  3192 9977
7 ALWAYS_EXCEPT="14b 28 $SANITYN_EXCEPT"
8 # UPDATE THE COMMENT ABOVE WITH BUG NUMBERS WHEN CHANGING ALWAYS_EXCEPT!
9
10 # bug number for skipped test:                                                    12652 12652
11 grep -q 'Enterprise Server 10' /etc/SuSE-release && ALWAYS_EXCEPT="$ALWAYS_EXCEPT 11    14" || true
12
13 # Tests that fail on uml
14 [ "$UML" = "true" ] && EXCEPT="$EXCEPT 7"
15
16 # Join file feature is not supported currently.
17 # It will be ported soon.
18 EXCEPT="$EXCEPT 22"
19
20 SRCDIR=`dirname $0`
21 PATH=$PWD/$SRCDIR:$SRCDIR:$SRCDIR/../utils:$PATH
22
23 SIZE=${SIZE:-40960}
24 CHECKSTAT=${CHECKSTAT:-"checkstat -v"}
25 CREATETEST=${CREATETEST:-createtest}
26 GETSTRIPE=${GETSTRIPE:-lfs getstripe}
27 SETSTRIPE=${SETSTRIPE:-lstripe}
28 MCREATE=${MCREATE:-mcreate}
29 OPENFILE=${OPENFILE:-openfile}
30 OPENUNLINK=${OPENUNLINK:-openunlink}
31 TOEXCL=${TOEXCL:-toexcl}
32 TRUNCATE=${TRUNCATE:-truncate}
33 export TMP=${TMP:-/tmp}
34 MOUNT_2=${MOUNT_2:-"yes"}
35 CHECK_GRANT=${CHECK_GRANT:-"yes"}
36 GRANT_CHECK_LIST=${GRANT_CHECK_LIST:-""}
37
38 SAVE_PWD=$PWD
39
40 export NAME=${NAME:-local}
41
42 LUSTRE=${LUSTRE:-`dirname $0`/..}
43 . $LUSTRE/tests/test-framework.sh
44 CLEANUP=${CLEANUP:-:}
45 SETUP=${SETUP:-:}
46 init_test_env $@
47 . ${CONFIG:=$LUSTRE/tests/cfg/$NAME.sh}
48
49 [ "$SLOW" = "no" ] && EXCEPT_SLOW="12 16"
50
51 SANITYLOG=${TESTSUITELOG:-$TMP/$(basename $0 .sh).log}
52 FAIL_ON_ERROR=false
53
54 SETUP=${SETUP:-:}
55 TRACE=${TRACE:-""}
56
57 LPROC=/proc/fs/lustre
58
59 [ "$SANITYLOG" ] && rm -f $SANITYLOG || true
60
61 check_and_setup_lustre
62
63 LPROC=/proc/fs/lustre
64 LOVNAME=`lctl get_param -n llite.*.lov.common_name | tail -n 1`
65 OSTCOUNT=`lctl get_param -n lov.$LOVNAME.numobd`
66
67 rm -rf $DIR1/[df][0-9]* $DIR1/lnk
68
69 # $RUNAS_ID may get set incorrectly somewhere else
70 [ $UID -eq 0 -a $RUNAS_ID -eq 0 ] && error "\$RUNAS_ID set to 0, but \$UID is also 0!"
71
72 check_runas_id $RUNAS_ID $RUNAS
73
74 build_test_filter
75
76 test_1a() {
77         touch $DIR1/f1
78         [ -f $DIR2/f1 ] || error
79 }
80 run_test 1a "check create on 2 mtpt's =========================="
81
82 test_1b() {
83         chmod 777 $DIR2/f1
84         $CHECKSTAT -t file -p 0777 $DIR1/f1 || error
85         chmod a-x $DIR2/f1
86 }
87 run_test 1b "check attribute updates on 2 mtpt's ==============="
88
89 test_1c() {
90         $CHECKSTAT -t file -p 0666 $DIR1/f1 || error
91 }
92 run_test 1c "check after remount attribute updates on 2 mtpt's ="
93
94 test_1d() {
95         rm $DIR2/f1
96         $CHECKSTAT -a $DIR1/f1 || error
97 }
98 run_test 1d "unlink on one mountpoint removes file on other ===="
99
100 test_2a() {
101         touch $DIR1/f2a
102         ls -l $DIR2/f2a
103         chmod 777 $DIR2/f2a
104         $CHECKSTAT -t file -p 0777 $DIR1/f2a || error
105 }
106 run_test 2a "check cached attribute updates on 2 mtpt's ========"
107
108 test_2b() {
109         touch $DIR1/f2b
110         ls -l $DIR2/f2b
111         chmod 777 $DIR1/f2b
112         $CHECKSTAT -t file -p 0777 $DIR2/f2b || error
113 }
114 run_test 2b "check cached attribute updates on 2 mtpt's ========"
115
116 # NEED TO SAVE ROOT DIR MODE
117 test_2c() {
118         chmod 777 $DIR1
119         $CHECKSTAT -t dir -p 0777 $DIR2 || error
120 }
121 run_test 2c "check cached attribute updates on 2 mtpt's root ==="
122
123 test_2d() {
124         chmod 755 $DIR1
125         $CHECKSTAT -t dir -p 0755 $DIR2 || error
126 }
127 run_test 2d "check cached attribute updates on 2 mtpt's root ==="
128
129 test_2e() {
130         chmod 755 $DIR1
131         ls -l $DIR1
132         ls -l $DIR2
133         chmod 777 $DIR1
134         $RUNAS dd if=/dev/zero of=$DIR2/$tfile count=1 || error
135 }
136 run_test 2e "check chmod on root is propagated to others"
137
138 test_3() {
139         ( cd $DIR1 ; ln -s this/is/good lnk )
140         [ "this/is/good" = "`perl -e 'print readlink("'$DIR2/lnk'");'`" ] || \
141                 error
142 }
143 run_test 3 "symlink on one mtpt, readlink on another ==========="
144
145 test_4() {
146         multifstat $DIR1/f4 $DIR2/f4
147 }
148 run_test 4 "fstat validation on multiple mount points =========="
149
150 test_5() {
151         mcreate $DIR1/f5
152         truncate $DIR2/f5 100
153         $CHECKSTAT -t file -s 100 $DIR1/f5 || error
154         rm $DIR1/f5
155 }
156 run_test 5 "create a file on one mount, truncate it on the other"
157
158 test_6() {
159         openunlink $DIR1/$tfile $DIR2/$tfile || \
160                 error "openunlink $DIR1/$tfile $DIR2/$tfile"
161 }
162 run_test 6 "remove of open file on other node =================="
163
164 test_7() {
165         # run_one creates uniq $tdir (bug 13798)
166         # opendirunlink failes if it exists
167         rmdir $DIR1/$tdir || true
168         opendirunlink $DIR1/$tdir $DIR2/$tdir || \
169                 error "opendirunlink $DIR1/$tdir $DIR2/$tdir"
170 }
171 run_test 7 "remove of open directory on other node ============="
172
173 test_8() {
174         opendevunlink $DIR1/$tfile $DIR2/$tfile || \
175                 error "opendevunlink $DIR1/$tfile $DIR2/$tfile"
176 }
177 run_test 8 "remove of open special file on other node =========="
178
179 test_9() {
180         MTPT=1
181         > $DIR2/f9
182         for C in a b c d e f g h i j k l; do
183                 DIR=`eval echo \\$DIR$MTPT`
184                 echo -n $C >> $DIR/f9
185                 [ "$MTPT" -eq 1 ] && MTPT=2 || MTPT=1
186         done
187         [ "`cat $DIR1/f9`" = "abcdefghijkl" ] || \
188                 error "`od -a $DIR1/f9` != abcdefghijkl"
189 }
190 run_test 9 "append of file with sub-page size on multiple mounts"
191
192 test_10a() {
193         MTPT=1
194         OFFSET=0
195         > $DIR2/f10
196         for C in a b c d e f g h i j k l; do
197                 DIR=`eval echo \\$DIR$MTPT`
198                 echo -n $C | dd of=$DIR/f10 bs=1 seek=$OFFSET count=1
199                 [ "$MTPT" -eq 1 ] && MTPT=2 || MTPT=1
200                 OFFSET=`expr $OFFSET + 1`
201         done
202         [ "`cat $DIR1/f10`" = "abcdefghijkl" ] || \
203                 error "`od -a $DIR1/f10` != abcdefghijkl"
204 }
205 run_test 10a "write of file with sub-page size on multiple mounts "
206
207 test_10b() {
208         yes "R" | dd of=$DIR1/f10b bs=3k count=1 || error "dd $DIR1"
209
210         truncate $DIR1/f10b 4096 || error "truncate 4096"
211
212         dd if=$DIR2/f10b of=$TMP/f10b-lustre bs=4k count=1 || error "dd $DIR2"
213
214         # create a test file locally to compare
215         yes "R" | dd of=$TMP/f10b bs=3k count=1 || error "dd random"
216         truncate $TMP/f10b 4096 || error "truncate 4096"
217         cmp $TMP/f10b $TMP/f10b-lustre || error "file miscompare"
218         rm $TMP/f10b $TMP/f10b-lustre
219 }
220 run_test 10b "write of file with sub-page size on multiple mounts "
221
222 test_11() {
223         mkdir $DIR1/d11
224         multiop_bg_pause $DIR1/d11/f O_c || return 1
225         MULTIPID=$!
226         cp -p /bin/ls $DIR1/d11/f
227         $DIR2/d11/f
228         RC=$?
229         kill -USR1 $MULTIPID
230         wait $MULTIPID || error
231         [ $RC -eq 0 ] && error || true
232 }
233 run_test 11 "execution of file opened for write should return error ===="
234
235 test_12() {
236        DIR=$DIR DIR2=$DIR2 sh lockorder.sh
237 }
238 run_test 12 "test lock ordering (link, stat, unlink) ==========="
239
240 test_13() {     # bug 2451 - directory coherency
241        rm -rf $DIR1/d13
242        mkdir $DIR1/d13 || error
243        cd $DIR1/d13 || error
244        ls
245        ( touch $DIR1/d13/f13 ) # needs to be a separate shell
246        ls
247        rm -f $DIR2/d13/f13 || error
248        ls 2>&1 | grep f13 && error "f13 shouldn't return an error (1)" || true
249        # need to run it twice
250        ( touch $DIR1/d13/f13 ) # needs to be a separate shell
251        ls
252        rm -f $DIR2/d13/f13 || error
253        ls 2>&1 | grep f13 && error "f13 shouldn't return an error (2)" || true
254 }
255 run_test 13 "test directory page revocation ===================="
256
257 test_14() {
258         mkdir $DIR1/d14
259         cp -p /bin/ls $DIR1/d14/ls
260         exec 100>> $DIR1/d14/ls
261         $DIR2/d14/ls && error || true
262         exec 100<&-
263 }
264 run_test 14 "execution of file open for write returns -ETXTBSY ="
265
266 test_14a() {
267         mkdir -p $DIR1/d14
268         cp -p `which multiop` $DIR1/d14/multiop || error "cp failed"
269         MULTIOP_PROG=$DIR1/d14/multiop multiop_bg_pause $TMP/test14.junk O_c || return 1
270         MULTIOP_PID=$!
271         multiop $DIR2/d14/multiop Oc && error "expected error, got success"
272         kill -USR1 $MULTIOP_PID || return 2
273         wait $MULTIOP_PID || return 3
274         rm $TMP/test14.junk $DIR1/d14/multiop || error "removing multiop"
275 }
276 run_test 14a "open(RDWR) of executing file returns -ETXTBSY ===="
277
278 test_14b() { # bug 3192, 7040
279         mkdir -p $DIR1/d14
280         cp -p `which multiop` $DIR1/d14/multiop || error "cp failed"
281         MULTIOP_PROG=$DIR1/d14/multiop multiop_bg_pause $TMP/test14.junk O_c || return 1
282         MULTIOP_PID=$!
283         truncate $DIR2/d14/multiop 0 && kill -9 $MULTIOP_PID && \
284                 error "expected truncate error, got success"
285         kill -USR1 $MULTIOP_PID || return 2
286         wait $MULTIOP_PID || return 3
287         cmp `which multiop` $DIR1/d14/multiop || error "binary changed"
288         rm $TMP/test14.junk $DIR1/d14/multiop || error "removing multiop"
289 }
290 run_test 14b "truncate of executing file returns -ETXTBSY ======"
291
292 test_14c() { # bug 3430, 7040
293         mkdir -p $DIR1/d14
294         cp -p `which multiop` $DIR1/d14/multiop || error "cp failed"
295         MULTIOP_PROG=$DIR1/d14/multiop multiop_bg_pause $TMP/test14.junk O_c || return 1
296         MULTIOP_PID=$!
297         cp /etc/hosts $DIR2/d14/multiop && error "expected error, got success"
298         kill -USR1 $MULTIOP_PID || return 2
299         wait $MULTIOP_PID || return 3
300         cmp `which multiop` $DIR1/d14/multiop || error "binary changed"
301         rm $TMP/test14.junk $DIR1/d14/multiop || error "removing multiop"
302 }
303 run_test 14c "open(O_TRUNC) of executing file return -ETXTBSY =="
304
305 test_14d() { # bug 10921
306         mkdir -p $DIR1/d14
307         cp -p `which multiop` $DIR1/d14/multiop || error "cp failed"
308         MULTIOP_PROG=$DIR1/d14/multiop multiop_bg_pause $TMP/test14.junk O_c || return 1
309         MULTIOP_PID=$!
310         log chmod
311         chmod 600 $DIR1/d14/multiop || error "chmod failed"
312         kill -USR1 $MULTIOP_PID || return 2
313         wait $MULTIOP_PID || return 3
314         cmp `which multiop` $DIR1/d14/multiop || error "binary changed"
315         rm $TMP/test14.junk $DIR1/d14/multiop || error "removing multiop"
316 }
317 run_test 14d "chmod of executing file is still possible ========"
318
319 test_15() {     # bug 974 - ENOSPC
320         echo "PATH=$PATH"
321         sh oos2.sh $MOUNT1 $MOUNT2
322         grant_error=`dmesg | grep "> available"`
323         [ -z "$grant_error" ] || error "$grant_error"
324 }
325 run_test 15 "test out-of-space with multiple writers ==========="
326
327 test_16() {
328         rm -f $MOUNT1/fsxfile
329         lfs setstripe $MOUNT1/fsxfile -c -1 # b=10919
330         fsx -c 50 -p 100 -N 2500 -l $((SIZE * 256)) -S 0 $MOUNT1/fsxfile $MOUNT2/fsxfile
331 }
332 run_test 16 "2500 iterations of dual-mount fsx ================="
333
334 test_17() { # bug 3513, 3667
335         [ ! -d /proc/fs/lustre/ost ] && skip "remote OST, skipping OST-only test" && return
336
337         cp /etc/termcap $DIR1/f17
338         cancel_lru_locks osc > /dev/null
339         #define OBD_FAIL_ONCE|OBD_FAIL_LDLM_CREATE_RESOURCE    0x30a
340         sysctl -w lustre.fail_loc=0x8000030a
341         ls -ls $DIR1/f17 | awk '{ print $1,$6 }' > $DIR1/f17-1 & \
342         ls -ls $DIR2/f17 | awk '{ print $1,$6 }' > $DIR2/f17-2
343         wait
344         diff -u $DIR1/f17-1 $DIR2/f17-2 || error "files are different"
345 }
346 run_test 17 "resource creation/LVB creation race ==============="
347
348 test_18() {
349         ./mmap_sanity -d $MOUNT1 -m $MOUNT2
350         sync; sleep 1; sync
351 }
352 run_test 18 "mmap sanity check ================================="
353
354 test_19() { # bug3811
355         [ -d /proc/fs/lustre/obdfilter ] || return 0
356
357         MAX=`cat /proc/fs/lustre/obdfilter/*/readcache_max_filesize | head -n 1`
358         for O in /proc/fs/lustre/obdfilter/*OST*; do
359                 echo 4096 > $O/readcache_max_filesize
360         done
361         dd if=/dev/urandom of=$TMP/f19b bs=512k count=32
362         SUM=`cksum $TMP/f19b | cut -d" " -f 1,2`
363         cp $TMP/f19b $DIR1/f19b
364         for i in `seq 1 20`; do
365                 [ $((i % 5)) -eq 0 ] && log "test_18 loop $i"
366                 cancel_lru_locks osc > /dev/null
367                 cksum $DIR1/f19b | cut -d" " -f 1,2 > $TMP/sum1 & \
368                 cksum $DIR2/f19b | cut -d" " -f 1,2 > $TMP/sum2
369                 wait
370                 [ "`cat $TMP/sum1`" = "$SUM" ] || \
371                         error "$DIR1/f19b `cat $TMP/sum1` != $SUM"
372                 [ "`cat $TMP/sum2`" = "$SUM" ] || \
373                         error "$DIR2/f19b `cat $TMP/sum2` != $SUM"
374         done
375         for O in /proc/fs/lustre/obdfilter/*OST*; do
376                 echo $MAX > $O/readcache_max_filesize
377         done
378         rm $DIR1/f19b
379 }
380 #run_test 19 "test concurrent uncached read races ==============="
381
382 test_20() {
383         mkdir $DIR1/d20
384         cancel_lru_locks osc
385         CNT=$((`cat /proc/fs/lustre/llite/*/dump_page_cache | wc -l`))
386         multiop $DIR1/f20 Ow8190c
387         multiop $DIR2/f20 Oz8194w8190c
388         multiop $DIR1/f20 Oz0r8190c
389         cancel_lru_locks osc
390         CNTD=$((`cat /proc/fs/lustre/llite/*/dump_page_cache | wc -l` - $CNT))
391         [ $CNTD -gt 0 ] && \
392             error $CNTD" page left in cache after lock cancel" || true
393 }
394 run_test 20 "test extra readahead page left in cache ===="
395
396 cleanup_21() {
397         trap 0
398         umount $DIR1/d21
399 }
400
401 test_21() { # Bug 5907
402         mkdir $DIR1/d21
403         mount /etc $DIR1/d21 --bind || error "mount failed" # Poor man's mount.
404         trap cleanup_21 EXIT
405         rmdir -v $DIR1/d21 && error "Removed mounted directory"
406         rmdir -v $DIR2/d21 && echo "Removed mounted directory from another mountpoint, needs to be fixed"
407         test -d $DIR1/d21 || error "Mounted directory disappeared"
408         cleanup_21
409         test -d $DIR2/d21 || test -d $DIR1/d21 && error "Removed dir still visible after umount"
410         true
411 }
412 run_test 21 " Try to remove mountpoint on another dir ===="
413
414 JOIN=${JOIN:-"lfs join"}
415
416 test_22() { # Bug 9926
417         mkdir $DIR1/d21
418         dd if=/dev/urandom of=$DIR1/d21/128k bs=1024 count=128
419         cp -p $DIR1/d21/128k $DIR1/d21/f_head
420         for ((i=0;i<10;i++)); do
421                 cp -p $DIR1/d21/128k $DIR1/d21/f_tail
422                 $JOIN $DIR1/d21/f_head $DIR1/d21/f_tail || error "join error"
423                 $CHECKSTAT -a $DIR1/d21/f_tail || error "tail file exist after join"
424         done
425         echo aaaaaaaaaaa >> $DIR1/d21/no_joined
426
427         mv $DIR2/d21/f_head $DIR2/
428         munlink $DIR2/f_head || error "unlink joined file error"
429         cat $DIR2/d21/no_joined || error "cat error"
430         rm -rf $DIR2/d21/no_joined || error "unlink normal file error"
431 }
432 run_test 22 " After joining in one dir,  open/close unlink file in anther dir" 
433
434 test_23() { # Bug 5972
435         echo "others should see updated atime while another read" > $DIR1/f23
436         
437         # clear the lock(mode: LCK_PW) gotten from creating operation
438         cancel_lru_locks osc
439         
440         time1=`date +%s`        
441         sleep 2
442         
443         multiop_bg_pause $DIR1/f23 or20_c || return 1
444         MULTIPID=$!
445
446         time2=`stat -c "%X" $DIR2/f23`
447
448         if (( $time2 <= $time1 )); then
449                 kill -USR1 $MULTIPID
450                 error "atime doesn't update among nodes"
451         fi
452
453         kill -USR1 $MULTIPID || return 1
454         rm -f $DIR1/f23 || error "rm -f $DIR1/f23 failed"
455         true
456 }
457 run_test 23 " others should see updated atime while another read===="
458
459 test_24() {
460         touch $DIR1/$tfile
461         lfs df || error "lfs df failed"
462         lfs df -ih || error "lfs df -ih failed"
463         lfs df -h $DIR1 || error "lfs df -h $DIR1 failed"
464         lfs df -i $DIR2 || error "lfs df -i $DIR2 failed"
465         lfs df $DIR1/$tfile || error "lfs df $DIR1/$tfile failed"
466         lfs df -ih $DIR2/$tfile || error "lfs df -ih $DIR2/$tfile failed"
467         
468         OSC=`lctl dl | awk '/-osc-|OSC.*MNT/ {print $4}' | head -n 1`
469 #       OSC=`lctl dl | awk '/-osc-/ {print $4}' | head -n 1`
470         lctl --device %$OSC deactivate
471         lfs df -i || error "lfs df -i with deactivated OSC failed"
472         lctl --device %$OSC recover
473         lfs df || error "lfs df with reactivated OSC failed"
474 }
475 run_test 24 "lfs df [-ih] [path] test ========================="
476
477 test_25() {
478         [ `lctl get_param -n mdc.*-mdc-*.connect_flags | grep -c acl` -lt 2 ] && \
479             skip "must have acl, skipping" && return
480
481         touch $DIR1/$tdir/f1 || error "touch $DIR1/$tdir/f1"
482         chmod 0755 $DIR1/$tdir/f1 || error "chmod 0755 $DIR1/$tdir/f1"
483
484         $RUNAS $CHECKSTAT $DIR2/$tdir/f1 || error "checkstat $DIR2/$tdir/f1 #1"
485         setfacl -m u:$RUNAS_ID:--- $DIR1/$tdir || error "setfacl $DIR2/$tdir #1"
486         $RUNAS $CHECKSTAT $DIR2/$tdir/f1 && error "checkstat $DIR2/$tdir/f1 #2"
487         setfacl -m u:$RUNAS_ID:r-x $DIR1/$tdir || error "setfacl $DIR2/$tdir #2"
488         $RUNAS $CHECKSTAT $DIR2/$tdir/f1 || error "checkstat $DIR2/$tdir/f1 #3"
489         setfacl -m u:$RUNAS_ID:--- $DIR1/$tdir || error "setfacl $DIR2/$tdir #3"
490         $RUNAS $CHECKSTAT $DIR2/$tdir/f1 && error "checkstat $DIR2/$tdir/f1 #4"
491         setfacl -x u:$RUNAS_ID: $DIR1/$tdir || error "setfacl $DIR2/$tdir #4"
492         $RUNAS $CHECKSTAT $DIR2/$tdir/f1 || error "checkstat $DIR2/$tdir/f1 #5"
493
494         rm -rf $DIR1/$tdir
495 }
496 run_test 25 "change ACL on one mountpoint be seen on another ==="
497
498 test_26a() {
499         utime $DIR1/f26a -s $DIR2/f26a || error
500 }
501 run_test 26a "allow mtime to get older"
502
503 test_26b() {
504         touch $DIR1/$tfile
505         sleep 1
506         echo "aaa" >> $DIR1/$tfile
507         sleep 1
508         chmod a+x $DIR2/$tfile
509         mt1=`stat -c %Y $DIR1/$tfile`
510         mt2=`stat -c %Y $DIR2/$tfile`
511         
512         if [ x"$mt1" != x"$mt2" ]; then 
513                 error "not equal mtime, client1: "$mt1", client2: "$mt2"."
514         fi
515 }
516 run_test 26b "sync mtime between ost and mds"
517
518 test_27() {
519         cancel_lru_locks osc
520         lctl clear
521         dd if=/dev/zero of=$DIR2/$tfile bs=$((4096+4))k conv=notrunc count=4 seek=3 &
522         DD2_PID=$!
523         usleep 50
524         log "dd 1 started"
525         
526         dd if=/dev/zero of=$DIR1/$tfile bs=$((16384-1024))k conv=notrunc count=1 seek=4 &
527         DD1_PID=$!
528         log "dd 2 started"
529         
530         sleep 1
531         dd if=/dev/zero of=$DIR1/$tfile bs=8k conv=notrunc count=1 seek=0
532         log "dd 3 finished"
533         lctl set_param -n ldlm.dump_namespaces ""
534         wait $DD1_PID $DD2_PID
535         [ $? -ne 0 ] && lctl dk $TMP/debug || true
536 }
537 run_test 27 "align non-overlapping extent locks from request ==="
538
539 test_28() { # bug 9977
540         ECHO_UUID="ECHO_osc1_UUID"
541         tOST=`$LCTL dl | | awk '/-osc-|OSC.*MNT/ { print $4 }' | head -1`
542
543         lfs setstripe $DIR1/$tfile -s 1048576 -i 0 -c 2
544         tOBJID=`lfs getstripe $DIR1/$tfile |grep "^[[:space:]]\+1" |awk '{print $2}'`
545         dd if=/dev/zero of=$DIR1/$tfile bs=1024k count=2
546
547         $LCTL <<-EOF
548                 newdev
549                 attach echo_client ECHO_osc1 $ECHO_UUID
550                 setup $tOST
551         EOF
552
553         tECHOID=`$LCTL dl | grep $ECHO_UUID | awk '{print $1}'`
554         $LCTL --device $tECHOID destroy "${tOBJID}:0"
555     
556         $LCTL <<-EOF
557                 cfg_device ECHO_osc1
558                 cleanup
559                 detach
560         EOF
561
562         # reading of 1st stripe should pass
563         dd if=$DIR2/$tfile of=/dev/null bs=1024k count=1 || error
564         # reading of 2nd stripe should fail (this stripe was destroyed)
565         dd if=$DIR2/$tfile of=/dev/null bs=1024k count=1 skip=1 && error
566
567         # now, recreating test file
568         dd if=/dev/zero of=$DIR1/$tfile bs=1024k count=2 || error
569         # reading of 1st stripe should pass
570         dd if=$DIR2/$tfile of=/dev/null bs=1024k count=1 || error
571         # reading of 2nd stripe should pass
572         dd if=$DIR2/$tfile of=/dev/null bs=1024k count=1 skip=1 || error
573 }
574 run_test 28 "read/write/truncate file with lost stripes"
575
576 test_29() { # bug 10999
577         touch $DIR1/$tfile
578         #define OBD_FAIL_LDLM_GLIMPSE  0x30f
579         sysctl -w lustre.fail_loc=0x8000030f
580         ls -l $DIR2/$tfile &
581         usleep 500
582         dd if=/dev/zero of=$DIR1/$tfile bs=4k count=1
583         wait
584 }
585 #bug 11549 - permanently turn test off in b1_5
586 #run_test 29 "lock put race between glimpse and enqueue ========="
587
588 test_30() { #bug #11110
589     cp -f /bin/bash $DIR1/$tdir/bash
590     /bin/sh -c 'sleep 1; rm -f $DIR2/$tdir/bash; cp /bin/bash $DIR2/$tdir' &
591     err=$($DIR1/$tdir/bash -c 'sleep 2; openfile -f O_RDONLY /proc/$$/exe >& /dev/null; echo $?')
592     wait
593     [ $err -ne 116 ] && error_ignore 12900 "return code ($err) != -ESTALE" && return
594     true
595 }
596
597 run_test 30 "recreate file race ========="
598
599 test_31() {
600         mkdir -p $DIR1/$tdir || error "Creating dir $DIR1/$tdir"
601         writes=`LANG=C dd if=/dev/zero of=$DIR/$tdir/$tfile count=1 2>&1 |
602                 awk 'BEGIN { FS="+" } /out/ {print $1}'`
603         #define OBD_FAIL_LDLM_CANCEL_BL_CB_RACE   0x314
604         sysctl -w lustre.fail_loc=0x314
605         reads=`LANG=C dd if=$DIR2/$tdir/$tfile of=/dev/null 2>&1 |
606                awk 'BEGIN { FS="+" } /in/ {print $1}'`
607         [ $reads -eq $writes ] || error "read" $reads "blocks, must be" $writes
608 }
609 run_test 31 "voluntary cancel / blocking ast race=============="
610
611 # enable/disable lockless truncate feature, depending on the arg 0/1
612 enable_lockless_truncate() {
613         lctl set_param -n llite.*.lockless_truncate $1
614 }
615
616 test_32a() { # bug 11270
617         local p="$TMP/sanityN-$TESTNAME.parameters"
618         save_lustre_params $HOSTNAME llite.*.lockless_truncate > $p
619         cancel_lru_locks osc
620         clear_llite_stats
621         enable_lockless_truncate 1
622         dd if=/dev/zero of=$DIR1/$tfile count=10 bs=1M > /dev/null 2>&1
623
624         log "checking cached lockless truncate"
625         $TRUNCATE $DIR1/$tfile 8000000
626         $CHECKSTAT -s 8000000 $DIR2/$tfile || error "wrong file size"
627         [ $(calc_llite_stats lockless_truncate) -eq 0 ] ||
628                 error "lockless truncate doesn't use cached locks"
629
630         log "checking not cached lockless truncate"
631         $TRUNCATE $DIR2/$tfile 5000000
632         $CHECKSTAT -s 5000000 $DIR1/$tfile || error "wrong file size"
633         [ $(calc_llite_stats lockless_truncate) -ne 0 ] ||
634                 error "not cached trancate isn't lockless"
635
636         log "disabled lockless truncate"
637         enable_lockless_truncate 0
638         clear_llite_stats
639         $TRUNCATE $DIR2/$tfile 3000000
640         $CHECKSTAT -s 3000000 $DIR1/$tfile || error "wrong file size"
641         [ $(calc_llite_stats lockless_truncate) -eq 0 ] ||
642                 error "lockless truncate disabling failed"
643         rm $DIR1/$tfile
644         # restore lockless_truncate default values
645         restore_lustre_params < $p
646         rm -f $p
647 }
648 run_test 32a "lockless truncate"
649
650 test_32b() { # bug 11270
651         local node
652         local p="$TMP/sanityN-$TESTNAME.parameters"
653         save_lustre_params $HOSTNAME "llite.*.contention_seconds" > $p
654         for node in $(osts_nodes); do
655                 save_lustre_params $node "ldlm.namespaces.filter-*.max_nolock_bytes" >> $p
656                 save_lustre_params $node "ldlm.namespaces.filter-*.contended_locks" >> $p
657                 save_lustre_params $node "ldlm.namespaces.filter-*.contention_seconds" >> $p
658         done
659         clear_llite_stats
660         # agressive lockless i/o settings 
661         for node in $(osts_nodes); do
662                 do_node $node 'lctl set_param -n ldlm.namespaces.filter-*.max_nolock_bytes 2000000; lctl set_param -n ldlm.namespaces.filter-*.contended_locks 0; lctl set_param -n ldlm.namespaces.filter-*.contention_seconds 60'
663         done
664         lctl set_param -n llite.*.contention_seconds 60
665         for i in $(seq 5); do
666                 dd if=/dev/zero of=$DIR1/$tfile bs=4k count=1 conv=notrunc > /dev/null 2>&1
667                 dd if=/dev/zero of=$DIR2/$tfile bs=4k count=1 conv=notrunc > /dev/null 2>&1
668         done
669         [ $(calc_llite_stats lockless_write_bytes) -ne 0 ] || error "lockless i/o was not triggered" 
670         # disable lockless i/o (it is disabled by default)
671         for node in $(osts_nodes); do
672                 do_node $node 'lctl set_param -n ldlm.namespaces.filter-*.max_nolock_bytes 0; lctl set_param -n ldlm.namespaces.filter-*.contended_locks 32; lctl set_param -n ldlm.namespaces.filter-*.contention_seconds 0'
673         done
674         # set contention_seconds to 0 at client too, otherwise Lustre still
675         # remembers lock contention
676         lctl set_param -n llite.*.contention_seconds 0
677         clear_llite_stats
678         for i in $(seq 5); do
679                 dd if=/dev/zero of=$DIR1/$tfile bs=4k count=1 conv=notrunc > /dev/null 2>&1
680                 dd if=/dev/zero of=$DIR2/$tfile bs=4k count=1 conv=notrunc > /dev/null 2>&1
681         done
682         [ $(calc_llite_stats lockless_write_bytes) -eq 0 ] ||
683                 error "lockless i/o works when disabled" 
684         rm -f $DIR1/$tfile
685         restore_lustre_params <$p
686         rm -f $p
687 }
688 run_test 32b "lockless i/o"
689
690 log "cleanup: ======================================================"
691
692 check_and_cleanup_lustre
693
694 echo '=========================== finished ==============================='
695 [ -f "$SANITYLOG" ] && cat $SANITYLOG && grep -q FAIL $SANITYLOG && exit 1 || true
696 echo "$0: completed"